    CR  EQU 13
    LF  EQU 10
    MODEL TINY
    CODESEG
    SMART
    JUMPS
    EVENDATA
    ORG 100h
    STARTUPCODE
    P8086

;  code 
        ;Print copyright
        Mov     AH, 9
        Lea     DX, Copy
        Int     21h
        ;Relocate our program 128 bytes lower.
        Call    RelCom
        ;Print status
        Mov     AH, 9
        Lea     DX, Inst
        Int     21h
        EXITCODE 0

;  data 
Copy    Db "RELCOM Sample R1.00.                         Relocates a COM program", CR, LF
        Db "Copyright (C) 1998 De Trans Software (D.T.S.).  All rights reserved.", CR, LF, CR, LF, '$'
Inst    Db "Sample succesfully relocated.", CR, LF, '$'

;  RelCom 
;RELCOM R1.00.                                          Relocates a COM program
;Copyright (C) 1998 De Trans Software (D.T.S.).             All rights reserved.
;
; FUNCTION: Relocates a COM program for executing in a lower memory address,
;           this allows you to save 128 bytes of memory (very useful for
;           TSR programs). This procedure should be located at the end of
;           your source, and called in the very first lines. The above only
;           works for COM programs (TINY memory model).
; INPUT:    Nothing.
; OUTPUT:   Nothing.
; NOTES:    AX, CX, SI, DI are destroyed. CS, DS, ES are updated to refer the
;           same addess as before relocating.
;
RelCom  PROC NEAR
RelComStart:
        ;Mov     CX, ((OFFSET RelComStart - 256) / 2) + 1
        Mov     CX, OFFSET RelComStart-256
        Shr     CX, 1
        Inc     CX
        Mov     SI, 256
        Mov     DI, 128
        Cld
        Rep     MovSw
        Mov     AX, DS
        Sub     AX, 8
        Mov     DS, AX
        Mov     ES, AX
        Pop     AX
        Push    DS
        Push    AX
        RetF
RelCom  ENDP
End
